Index: CKEditor/branches/versions/3.5.x/_source/plugins/showblocks/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/showblocks/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/showblocks/plugin.js	(revision 6050)
@@ -25,7 +25,8 @@
 		'{'+
 			'background-repeat: no-repeat;'+
+			'background-position: top %3;'+
 			'border: 1px dotted gray;'+
 			'padding-top: 8px;'+
-			'padding-left: 8px;'+
+			'padding-%3: 8px;'+
 		'}'+
 
@@ -85,5 +86,5 @@
 		'}';
 
-	var cssTemplateRegex = /%1/g, cssClassRegex = /%2/g;
+	var cssTemplateRegex = /%1/g, cssClassRegex = /%2/g, backgroundPositionRegex = /%3/g;
 
 	var commandDefinition =
@@ -119,5 +120,6 @@
 			editor.addCss( cssTemplate
 				.replace( cssTemplateRegex, 'background-image: url(' + CKEDITOR.getUrl( this.path ) + 'images/block_' )
-				.replace( cssClassRegex, 'cke_show_blocks ' ) );
+				.replace( cssClassRegex, 'cke_show_blocks ' )
+				.replace( backgroundPositionRegex, editor.lang.dir == 'rtl' ? 'right' : 'left' ) );
 
 			editor.ui.addButton( 'ShowBlocks',
@@ -152,3 +154,2 @@
  * config.startupOutlineBlocks = true;
  */
-CKEDITOR.config.startupOutlineBlocks = false;
Index: CKEditor/branches/versions/3.5.x/_source/plugins/smiley/dialogs/smiley.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/smiley/dialogs/smiley.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/smiley/dialogs/smiley.js	(revision 6050)
@@ -37,5 +37,7 @@
 					_cke_saved_src : src,
 					title : title,
-					alt : title
+					alt : title,
+					width : target.$.width,
+					height : target.$.height
 				}
 			});
@@ -53,6 +55,6 @@
 		var relative, nodeToMove;
 
-		var keystroke = ev.getKeystroke();
-		var rtl = editor.lang.dir == 'rtl';
+		var keystroke = ev.getKeystroke(),
+			rtl = editor.lang.dir == 'rtl';
 		switch ( keystroke )
 		{
Index: CKEditor/branches/versions/3.5.x/_source/plugins/sourcearea/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/sourcearea/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/sourcearea/plugin.js	(revision 6050)
@@ -73,10 +73,10 @@
 								setTimeout( onResize, 0 );
 							}
-							else
-							{
-								// By some yet unknown reason, we must stop the
-								// mousedown propagation for the textarea,
-								// otherwise it's not possible to place the caret
-								// inside of it (non IE).
+							// As we prevent click to put focus on editor container,
+							// while 'mousedown' inside <textarea> is also captured,
+							// but we must stop the even propagation, otherwise
+							// it's not possible to place the caret inside of it (non IE and IE9).
+							if ( document.addEventListener )
+							{
 								textarea.on( 'mousedown', function( evt )
 									{
Index: CKEditor/branches/versions/3.5.x/_source/plugins/specialchar/dialogs/specialchar.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/specialchar/dialogs/specialchar.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/specialchar/dialogs/specialchar.js	(revision 6050)
@@ -113,6 +113,6 @@
 		var element = ev.getTarget();
 		var relative, nodeToMove;
-		var keystroke = ev.getKeystroke();
-		var rtl = editor.lang.dir == 'rtl';
+		var keystroke = ev.getKeystroke(),
+			rtl = editor.lang.dir == 'rtl';
 
 		switch ( keystroke )
@@ -348,9 +348,9 @@
 								{
 									var firstChar = this.getElement().getElementsByTag( 'a' ).getItem( 0 );
-									setTimeout(function()
+									setTimeout( function()
 									{
 										firstChar.focus();
 										onFocus( null, firstChar );
-									});
+									}, 0 );
 								},
 								onShow : function()
@@ -361,5 +361,5 @@
 											firstChar.focus();
 											onFocus( null, firstChar );
-										});
+										}, 0 );
 								},
 								onLoad : function( event )
Index: CKEditor/branches/versions/3.5.x/_source/plugins/styles/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/styles/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/styles/plugin.js	(revision 6050)
@@ -138,4 +138,6 @@
 						this.type == CKEDITOR.STYLE_INLINE ?
 							removeInlineStyle
+						: this.type == CKEDITOR.STYLE_OBJECT ?
+							removeObjectStyle
 						: null ).call( this, range );
 		},
@@ -477,8 +479,20 @@
 			{
 				// Build the style element, based on the style object definition.
-				var styleNode = getElement( this, document );
+				var styleNode = getElement( this, document ),
+					styleHasAttrs = styleNode.hasAttributes();
 
 				// Get the element that holds the entire range.
 				var parent = styleRange.getCommonAncestor();
+
+				var removeList = {
+					styles : {},
+					attrs : {},
+					// Styles cannot be removed.
+					blockedStyles : {},
+					// Attrs cannot be removed.
+					blockedAttrs : {}
+				};
+
+				var attName, styleName, value;
 
 				// Loop through the parents, removing the redundant attributes
@@ -488,20 +502,24 @@
 					if ( parent.getName() == elementName )
 					{
-						for ( var attName in def.attributes )
+						for ( attName in def.attributes )
 						{
-							if ( styleNode.getAttribute( attName ) == parent.getAttribute( attName ) )
-								styleNode.removeAttribute( attName );
+							if ( removeList.blockedAttrs[ attName ] || !( value = parent.getAttribute( styleName ) ) )
+								continue;
+
+							if ( styleNode.getAttribute( attName ) == value )
+								removeList.attrs[ attName ] = 1;
+							else
+								removeList.blockedAttrs[ attName ] = 1;
 						}
 
-						for ( var styleName in def.styles )
+						for ( styleName in def.styles )
 						{
-							if ( styleNode.getStyle( styleName ) == parent.getStyle( styleName ) )
-								styleNode.removeStyle( styleName );
-						}
-
-						if ( !styleNode.hasAttributes() )
-						{
-							styleNode = null;
-							break;
+							if ( removeList.blockedStyles[ styleName ] || !( value = parent.getStyle( styleName ) ) )
+								continue;
+
+							if ( styleNode.getStyle( styleName ) == value )
+								removeList.styles[ styleName ] = 1;
+							else
+								removeList.blockedStyles[ styleName ] = 1;
 						}
 					}
@@ -509,4 +527,13 @@
 					parent = parent.getParent();
 				}
+
+				for ( attName in removeList.attrs )
+					styleNode.removeAttribute( attName );
+
+				for ( styleName in removeList.styles )
+					styleNode.removeStyle( styleName );
+
+				if ( styleHasAttrs && !styleNode.hasAttributes() )
+					styleNode = null;
 
 				if ( styleNode )
@@ -534,4 +561,13 @@
 					if ( !CKEDITOR.env.ie )
 						styleNode.$.normalize();
+				}
+				// Style already inherit from parents, left just to clear up any internal overrides. (#5931)
+				else
+				{
+					styleNode = new CKEDITOR.dom.element( 'span' );
+					styleRange.extractContents().appendTo( styleNode );
+					styleRange.insertNode( styleNode );
+					removeFromInsideElement( this, styleNode );
+					styleNode.remove( true );
 				}
 
@@ -720,4 +756,39 @@
 	}
 
+	function removeObjectStyle( range )
+	{
+		var root = range.getCommonAncestor( true, true ),
+				element = root.getAscendant( this.element, true );
+
+		if ( !element )
+			return;
+
+		var style = this;
+		var def = style._.definition;
+		var attributes = def.attributes;
+		var styles = CKEDITOR.style.getStyleText( def );
+
+		// Remove all defined attributes.
+		if ( attributes )
+		{
+			for ( var att in attributes )
+			{
+				element.removeAttribute( att, attributes[ att ] );
+			}
+		}
+
+		// Assign all defined styles.
+		if ( def.styles )
+		{
+			for ( var i in def.styles )
+			{
+				if ( !def.styles.hasOwnProperty( i ) )
+					continue;
+
+				element.removeStyle( i );
+			}
+		}
+	}
+
 	function applyBlockStyle( range )
 	{
@@ -739,5 +810,5 @@
 		while ( ( block = iterator.getNextParagraph() ) )		// Only one =
 		{
-			var newBlock = getElement( this, doc );
+			var newBlock = getElement( this, doc, block );
 			replaceBlock( block, newBlock );
 		}
@@ -1047,5 +1118,5 @@
 	}
 
-	function getElement( style, targetDocument )
+	function getElement( style, targetDocument, element )
 	{
 		var el;
@@ -1062,4 +1133,8 @@
 		el = new CKEDITOR.dom.element( elementName, targetDocument );
 
+		// #6226: attributes should be copied before the new ones are applied
+		if ( element )
+			element.copyAttributes( el );
+
 		return setupElement( el, style );
 	}
@@ -1081,5 +1156,5 @@
 
 		// Assign all defined styles.
-		if ( styles )
+		if( styles )
 			el.setAttribute( 'style', styles );
 
@@ -1232,5 +1307,9 @@
 		return styleText.replace( /\s*([;:])\s*/, '$1' )
 							 .replace( /([^\s;])$/, '$1;')
-							 .replace( /,\s+/g, ',' ) // Trimming spaces after comma (e.g. font-family name)(#4107).
+				 			// Trimming spaces after comma(#4107),
+				 			// remove quotations(#6403),
+				 			// mostly for differences on "font-family".
+							 .replace( /,\s+/g, ',' )
+							 .replace( /\"/g,'' )
 							 .toLowerCase();
 	}
@@ -1276,6 +1355,6 @@
 		var selection = document.getSelection(),
 			// Bookmark the range so we can re-select it after processing.
-			bookmarks = selection.createBookmarks(),
-			ranges = selection.getRanges( true ),
+			bookmarks = selection.createBookmarks( 1 ),
+			ranges = selection.getRanges( 1 ),
 			func = remove ? this.removeFromRange : this.applyToRange,
 			range;
@@ -1288,5 +1367,5 @@
 		{
 			selection.selectRanges( ranges );
-			bookmarks[0].startNode.remove();
+			document.getById( bookmarks[ 0 ].startNode ).remove();
 		}
 		else
Index: CKEditor/branches/versions/3.5.x/_source/plugins/stylescombo/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/stylescombo/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/stylescombo/plugin.js	(revision 6050)
@@ -27,5 +27,5 @@
 
 						// Put all styles into an Array.
-						for ( var i = 0 ; i < stylesDefinitions.length ; i++ )
+						for ( var i = 0, count = stylesDefinitions.length ; i < count ; i++ )
 						{
 							var styleDefinition = stylesDefinitions[ i ];
@@ -72,5 +72,5 @@
 								// combo.
 								var lastType;
-								for ( var i = 0 ; i < stylesList.length ; i++ )
+								for ( var i = 0, count = stylesList.length ; i < count ; i++ )
 								{
 									style = stylesList[ i ];
@@ -109,4 +109,6 @@
 						if ( style.type == CKEDITOR.STYLE_INLINE && style.checkActive( elementPath ) )
 							style.remove( editor.document );
+						else if ( style.type == CKEDITOR.STYLE_OBJECT && style.checkActive( elementPath ) )
+							style.remove( editor.document );
 						else
 							style.apply( editor.document );
@@ -125,5 +127,5 @@
 
 								// For each element into the elements path.
-								for ( var i = 0, element ; i < elements.length ; i++ )
+								for ( var i = 0, count = elements.length, element ; i < count ; i++ )
 								{
 									element = elements[i];
@@ -153,7 +155,6 @@
 							editor.focus();
 
-						var selection = editor.getSelection();
-
-						var element = selection.getSelectedElement(),
+						var selection = editor.getSelection(),
+							element = selection.getSelectedElement(),
 							elementPath = new CKEDITOR.dom.elementPath( element || selection.getStartElement() );
 
Index: CKEditor/branches/versions/3.5.x/_source/plugins/table/dialogs/table.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/table/dialogs/table.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/table/dialogs/table.js	(revision 6050)
@@ -120,5 +120,5 @@
 				{
 					var selection = editor.getSelection(),
-						bms = editor.getSelection().createBookmarks();
+						bms = selection.createBookmarks();
 				}
 
@@ -167,5 +167,6 @@
 						{
 							var th = theRow.getChild( i );
-							if ( th.type == CKEDITOR.NODE_ELEMENT )
+							// Skip bookmark nodes. (#6155)
+							if ( th.type == CKEDITOR.NODE_ELEMENT && !th.hasAttribute( '_cke_bookmark' ) )
 							{
 								th.renameNode( 'th' );
@@ -604,6 +605,5 @@
 										{
 											var caption = nodeList.getItem( 0 );
-											caption = ( caption.getChild( 0 ) && caption.getChild( 0 ).getText() ) || '';
-											caption = CKEDITOR.tools.trim( caption );
+											caption = CKEDITOR.tools.trim( caption.getText() );
 											this.setValue( caption );
 										}
Index: CKEditor/branches/versions/3.5.x/_source/plugins/table/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/table/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/table/plugin.js	(revision 6050)
@@ -59,8 +59,8 @@
 			editor.contextMenu.addListener( function( element, selection )
 				{
-					if ( !element || element.isReadOnly())
+					if ( !element || element.isReadOnly() )
 						return null;
 
-					var isTable	= element.is( 'table' ) || element.hasAscendant( 'table' );
+					var isTable = element.hasAscendant( 'table', 1 );
 
 					if ( isTable )
Index: CKEditor/branches/versions/3.5.x/_source/plugins/tableresize/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/tableresize/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/tableresize/plugin.js	(revision 6050)
@@ -394,5 +394,5 @@
 		}
 
-		target.getAscendant( 'table', true ).removeCustomData( '_cke_table_pillars' );
+		target.getAscendant( 'table', 1 ).removeCustomData( '_cke_table_pillars' );
 		evt.removeListener();
 	}
@@ -424,8 +424,8 @@
 							pillars;
 
-						if ( !target.is( 'table' ) && !target.getAscendant( 'tbody', true ) )
+						if ( !target.is( 'table' ) && !target.getAscendant( 'tbody', 1 ) )
 							return;
 
-						table = target.getAscendant( 'table', true );
+						table = target.getAscendant( 'table', 1 );
 
 						if ( !( pillars = table.getCustomData( '_cke_table_pillars' ) ) )
Index: CKEditor/branches/versions/3.5.x/_source/plugins/tabletools/dialogs/tableCell.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/tabletools/dialogs/tableCell.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/tabletools/dialogs/tableCell.js	(revision 6050)
@@ -26,9 +26,11 @@
 			{
 				releaseHandlers( this );
-				callback( this );
+				callback( this, this._.parentDialog );
+				this._.parentDialog.changeFocus( true );
 			};
 			var onCancel = function()
 			{
 				releaseHandlers( this );
+				this._.parentDialog.changeFocus();
 			};
 			var releaseHandlers = function( dialog )
@@ -523,4 +525,11 @@
 
 				selection.selectBookmarks( bookmarks );
+
+				// Force selectionChange event because of alignment style.
+				var firstElement = selection.getStartElement();
+				var currentPath = new CKEDITOR.dom.elementPath( firstElement );
+
+				this._.editor._.selectionPreviousPath = currentPath;
+				this._.editor.fire( 'selectionChange', { selection : selection, path : currentPath, element : firstElement } );
 			}
 		};
Index: CKEditor/branches/versions/3.5.x/_source/plugins/tabletools/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/tabletools/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/tabletools/plugin.js	(revision 6050)
@@ -147,12 +147,12 @@
 
 		// Create a clone of the row.
-		var newRow = row.clone( true );
-
-		// Insert the new row before of it.
-		newRow.insertBefore( row );
-
-		// Clean one of the rows to produce the illusion of inserting an empty row
-		// before or after.
-		clearRow( insertBefore ? newRow.$ : row.$ );
+		var newRow = row.clone( 1 );
+
+		insertBefore ?
+			newRow.insertBefore( row ) :
+			newRow.insertAfter( row );
+
+		// Clean the new row.
+		clearRow( newRow.$ );
 	}
 
@@ -217,5 +217,5 @@
 		// Get the cell where the selection is placed in.
 		var startElement = selection.getStartElement();
-		var cell = startElement.getAscendant( 'td', true ) || startElement.getAscendant( 'th', true );
+		var cell = startElement.getAscendant( 'td', 1 ) || startElement.getAscendant( 'th', 1 );
 
 		if ( !cell )
@@ -235,5 +235,5 @@
 				continue;
 
-			cell = ( new CKEDITOR.dom.element( $row.cells[ cellIndex ] ) ).clone( false );
+			cell = ( new CKEDITOR.dom.element( $row.cells[ cellIndex ] ) ).clone( 0 );
 
 			if ( !CKEDITOR.env.ie )
@@ -340,5 +340,5 @@
 	{
 		var startElement = selection.getStartElement();
-		var cell = startElement.getAscendant( 'td', true ) || startElement.getAscendant( 'th', true );
+		var cell = startElement.getAscendant( 'td', 1 ) || startElement.getAscendant( 'th', 1 );
 
 		if ( !cell )
@@ -715,7 +715,7 @@
 					exec : function( editor )
 					{
-						var selection = editor.getSelection();
-						var startElement = selection && selection.getStartElement();
-						var table = startElement && startElement.getAscendant( 'table', true );
+						var selection = editor.getSelection(),
+							startElement = selection && selection.getStartElement(),
+							table = startElement && startElement.getAscendant( 'table', 1 );
 
 						if ( !table )
@@ -728,7 +728,7 @@
 						selection.selectRanges( [ range ] );
 
-						// If the table's parent has only one child, remove it,except body,as well.( #5416 )
+						// If the table's parent has only one child remove it as well (unless it's the body or a table cell) (#5416, #6289)
 						var parent = table.getParent();
-						if ( parent.getChildCount() == 1 && parent.getName() != 'body' )
+						if ( parent.getChildCount() == 1 && !parent.is( 'body', 'td', 'th' ) )
 							parent.remove();
 						else
Index: CKEditor/branches/versions/3.5.x/_source/plugins/toolbar/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/toolbar/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/toolbar/plugin.js	(revision 6050)
@@ -158,5 +158,5 @@
 						editor.toolbox = new toolbox();
 
-						var labelId = 'cke_' + CKEDITOR.tools.getNextNumber();
+						var labelId = CKEDITOR.tools.getNextId();
 
 						var output = [ '<div class="cke_toolbox" role="toolbar" aria-labelledby="', labelId, '"' ],
@@ -188,5 +188,5 @@
 								continue;
 
-							var toolbarId = 'cke_' + CKEDITOR.tools.getNextNumber(),
+							var toolbarId = CKEDITOR.tools.getNextId(),
 								toolbarObj = { id : toolbarId, items : [] };
 
@@ -284,11 +284,11 @@
 								{
 									editor.execCommand( 'toolbarCollapse' );
-								} );
+								});
 
 							editor.on( 'destroy', function () {
 									CKEDITOR.tools.removeFunction( collapserFn );
-								} );
-
-							var collapserId = 'cke_' + CKEDITOR.tools.getNextNumber();
+								});
+
+							var collapserId = CKEDITOR.tools.getNextId();
 
 							editor.addCommand( 'toolbarCollapse',
@@ -296,11 +296,11 @@
 									exec : function( editor )
 									{
-										var collapser = CKEDITOR.document.getById( collapserId );
-										var toolbox = collapser.getPrevious();
-										var contents = editor.getThemeSpace( 'contents' );
-										var toolboxContainer = toolbox.getParent();
-										var contentHeight = parseInt( contents.$.style.height, 10 );
-										var previousHeight = toolboxContainer.$.offsetHeight;
-										var collapsed = !toolbox.isVisible();
+										var collapser = CKEDITOR.document.getById( collapserId ),
+											toolbox = collapser.getPrevious(),
+											contents = editor.getThemeSpace( 'contents' ),
+											toolboxContainer = toolbox.getParent(),
+											contentHeight = parseInt( contents.$.style.height, 10 ),
+											previousHeight = toolboxContainer.$.offsetHeight,
+											collapsed = !toolbox.isVisible();
 
 										if ( !collapsed )
Index: CKEditor/branches/versions/3.5.x/_source/plugins/uicolor/lang/he.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/uicolor/lang/he.js	(revision 6050)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/uicolor/lang/he.js	(revision 6050)
@@ -0,0 +1,15 @@
+﻿/*
+Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+CKEDITOR.plugins.setLang( 'uicolor', 'he',
+{
+	uicolor :
+	{
+		title : 'בחירת צבע ממשק משתמש',
+		preview : 'תצוגה מקדימה',
+		config : 'הדבק את הטקסט הבא לתוך הקובץ config.js',
+		predefined : 'קבוצות צבעים מוגדרות מראש'
+	}
+});
Index: CKEditor/branches/versions/3.5.x/_source/plugins/uicolor/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/uicolor/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/uicolor/plugin.js	(revision 6050)
@@ -7,5 +7,5 @@
 {
 	requires : [ 'dialog' ],
-	lang : [ 'en' ],
+	lang : [ 'en', 'he' ],
 
 	init : function( editor )
Index: CKEditor/branches/versions/3.5.x/_source/plugins/undo/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/undo/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/undo/plugin.js	(revision 6050)
@@ -134,5 +134,5 @@
 			{
 				if ( undoManager.currentImage && new Image( editor ).equals( undoManager.currentImage ) )
-					setTimeout( function () { undoManager.update(); }, 0 );
+					setTimeout( function() { undoManager.update(); }, 0 );
 			});
 		}
@@ -340,5 +340,5 @@
 			this.index = -1;
 
-			this.limit = this.editor.config.undoStackSize;
+			this.limit = this.editor.config.undoStackSize || 20;
 
 			this.currentImage = null;
@@ -546,5 +546,4 @@
  * config.undoStackSize = 50;
  */
-CKEDITOR.config.undoStackSize = 20;
 
 /**
Index: CKEditor/branches/versions/3.5.x/_source/plugins/wysiwygarea/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/wysiwygarea/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/wysiwygarea/plugin.js	(revision 6050)
@@ -15,5 +15,5 @@
 
 	// Matching an empty paragraph at the end of document.
-	var emptyParagraphRegexp = /\s*<(p|div|address|h\d|center|li)[^>]*>\s*(?:<br[^>]*>|&nbsp;|\u00A0|&#160;)?\s*(:?<\/\1>)?\s*(?=$|<\/body>)/gi;
+	var emptyParagraphRegexp = /(^|<body\b[^>]*>)\s*<(p|div|address|h\d|center)[^>]*>\s*(?:<br[^>]*>|&nbsp;|\u00A0|&#160;)?\s*(:?<\/\2>)?\s*(?=$|<\/body>)/gi;
 
 	var notWhitespaceEval = CKEDITOR.dom.walker.whitespaces( true );
@@ -74,5 +74,9 @@
 				}
 
-				$sel.createRange().pasteHTML( data );
+				try
+				{
+					$sel.createRange().pasteHTML( data );
+				}
+				catch (e) {}
 
 				if ( selIsLocked )
@@ -89,4 +93,5 @@
 				marker.scrollIntoView();
 				marker.remove();
+				marker = null;
 			}
 
@@ -129,5 +134,5 @@
 				range.deleteContents();
 
-				clone = !i && element || element.clone( true );
+				clone = !i && element || element.clone( 1 );
 
 				// If we're inserting a block at dtd-violated position, split
@@ -136,5 +141,5 @@
 				if ( isBlock )
 				{
-					while ( ( current = range.getCommonAncestor( false, true ) )
+					while ( ( current = range.getCommonAncestor( 0, 1 ) )
 							&& ( dtd = CKEDITOR.dtd[ current.getName() ] )
 							&& !( dtd && dtd [ elementName ] ) )
@@ -199,5 +204,5 @@
 	{
 		if ( !editor.checkDirty() )
-			setTimeout( function(){ editor.resetDirty(); } );
+			setTimeout( function(){ editor.resetDirty(); }, 0 );
 	}
 
@@ -245,4 +250,10 @@
 			restoreDirty( editor );
 
+			// Memorize scroll position to restore it later (#4472).
+			var hostDocument = editor.element.getDocument();
+			var hostDocumentElement = hostDocument.getDocumentElement();
+			var scrollTop = hostDocumentElement.$.scrollTop;
+			var scrollLeft = hostDocumentElement.$.scrollLeft;
+
 			// Simulating keyboard character input by dispatching a keydown of white-space text.
 			var keyEventSimulate = doc.$.createEvent( "KeyEvents" );
@@ -250,4 +261,7 @@
 				false, false, false, 0, 32 );
 			doc.$.dispatchEvent( keyEventSimulate );
+
+			if ( scrollTop != hostDocumentElement.$.scrollTop || scrollLeft != hostDocumentElement.$.scrollLeft )
+				hostDocument.getWindow().$.scrollTo( scrollLeft, scrollTop );
 
 			// Restore the original document status by placing the cursor before a bogus br created (#5021).
@@ -518,5 +532,5 @@
 						CKEDITOR.env.gecko && CKEDITOR.tools.setTimeout( activateEditing, 0, null, editor );
 
-						domWindow	= editor.window		= new CKEDITOR.dom.window( domWindow );
+						domWindow	= editor.window	= new CKEDITOR.dom.window( domWindow );
 						domDocument	= editor.document	= new CKEDITOR.dom.document( domDocument );
 
@@ -530,5 +544,5 @@
 
 						// Gecko/Webkit need some help when selecting control type elements. (#3448)
-						if ( !( CKEDITOR.env.ie || CKEDITOR.env.opera) )
+						if ( !( CKEDITOR.env.ie || CKEDITOR.env.opera ) )
 						{
 							domDocument.on( 'mousedown', function( ev )
@@ -613,4 +627,6 @@
 							});
 
+						var wasFocused;
+
 						domWindow.on( 'focus', function()
 							{
@@ -621,4 +637,13 @@
 								else if ( CKEDITOR.env.opera )
 									doc.getBody().focus();
+								// Webkit needs focus for the first time on the HTML element. (#6153)
+								else if ( CKEDITOR.env.webkit )
+								{
+									if ( !wasFocused )
+									{
+										editor.document.getDocumentElement().focus();
+										wasFocused = 1;
+									}
+								}
 
 								editor.focusManager.focus();
@@ -861,7 +886,7 @@
 									data = editor.dataProcessor.toDataFormat( data, fixForBody );
 
-								// Strip the last blank paragraph within document.
+								// Reset empty if the document contains only one empty paragraph.
 								if ( config.ignoreEmptyParagraph )
-									data = data.replace( emptyParagraphRegexp, '' );
+									data = data.replace( emptyParagraphRegexp, function( match, lookback ) { return lookback; } );
 
 								if ( docType )
@@ -918,4 +943,8 @@
 								else if ( CKEDITOR.env.opera && editor.document )
 								{
+									// Required for Opera when switching focus
+									// from another iframe, e.g. panels. (#6444)
+									var iframe = editor.window.$.frameElement;
+									iframe.blur(), iframe.focus();
 									editor.document.getBody().focus();
 
@@ -940,5 +969,5 @@
 			// Setting voice label as window title, backup the original one
 			// and restore it before running into use.
-			editor.on( 'contentDom', function ()
+			editor.on( 'contentDom', function()
 				{
 					var title = editor.document.getElementsByTag( 'title' ).getItem( 0 );
@@ -958,4 +987,7 @@
 				editor.addCss( selectors.join( ',' ) + '{ display:inline-block;}' );
 			}
+			// Set the HTML style to 100% to have the text cursor in affect (#6341)
+			else if ( CKEDITOR.env.gecko )
+				editor.addCss( 'html { height: 100% !important; }' );
 
 			// Switch on design mode for a short while and close it after then.
@@ -966,8 +998,9 @@
 					{
 						editor.document.$.designMode = 'on';
-						setTimeout( function ()
+						setTimeout( function()
 						{
 							editor.document.$.designMode = 'off';
-							editor.document.getBody().focus();
+							if ( CKEDITOR.currentInstance == editor )
+								editor.document.getBody().focus();
 						}, 50 );
 					},
@@ -1031,5 +1064,5 @@
 	if ( CKEDITOR.env.gecko )
 	{
-		( function ()
+		(function()
 		{
 			var body = document.body;
Index: CKEditor/branches/versions/3.5.x/_source/skins/kama/skin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/skins/kama/skin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/skins/kama/skin.js	(revision 6050)
@@ -148,5 +148,5 @@
 					var cssContent,
 						uiStyle = getStylesheet( CKEDITOR.document ),
-						cssId = '.cke_editor_' + CKEDITOR.tools.escapeCssSelector( editor.name );
+						cssId = '.' + editor.id;
 
 					var cssSelectors =
@@ -243,9 +243,9 @@
 						// ml
 						el = innerDialog.getChild( 4 );
-						el.setStyle( 'height', ( body.$.offsetHeight - 31 - 14 ) + 'px' );
+						el.setStyle( 'height', ( height + body.getChild(0).$.offsetHeight ) + 'px' );
 
 						// mr
 						el = innerDialog.getChild( 5 );
-						el.setStyle( 'height', ( body.$.offsetHeight - 31 - 14 ) + 'px' );
+						el.setStyle( 'height', ( height + body.getChild(0).$.offsetHeight ) + 'px' );
 					},
 					100 );
Index: CKEditor/branches/versions/3.5.x/_source/skins/office2003/skin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/skins/office2003/skin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/skins/office2003/skin.js	(revision 6050)
@@ -66,9 +66,9 @@
 						// ml
 						el = innerDialog.getChild( 4 );
-						el.setStyle( 'height', ( body.$.offsetHeight - 31 - 14 ) + 'px' );
+						el.setStyle( 'height', ( height + body.getChild(0).$.offsetHeight ) + 'px' );
 
 						// mr
 						el = innerDialog.getChild( 5 );
-						el.setStyle( 'height', ( body.$.offsetHeight - 31 - 14 ) + 'px' );
+						el.setStyle( 'height', ( height + body.getChild(0).$.offsetHeight ) + 'px' );
 					};
 				setTimeout( fixSize, 100 );
Index: CKEditor/branches/versions/3.5.x/_source/skins/v2/skin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/skins/v2/skin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/skins/v2/skin.js	(revision 6050)
@@ -66,9 +66,9 @@
 						// ml
 						el = innerDialog.getChild( 4 );
-						el.setStyle( 'height', ( body.$.offsetHeight - 31 - 14 ) + 'px' );
+						el.setStyle( 'height', ( height + body.getChild(0).$.offsetHeight ) + 'px' );
 
 						// mr
 						el = innerDialog.getChild( 5 );
-						el.setStyle( 'height', ( body.$.offsetHeight - 31 - 14 ) + 'px' );
+						el.setStyle( 'height', ( height + body.getChild(0).$.offsetHeight ) + 'px' );
 					},
 					100 );
